#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <linux/kdev_t.h>
#include <rsbac/types.h>
#include <rsbac/syscalls.h>
#include <rsbac/getname.h>
#include <rsbac/error.h>
#include "nls.h"

int main(int argc, char ** argv)
{
  int res = 0;
  rsbac_security_level_t seclevel;
  char * progname;
  int verbose = 0;
  int current = 0;

  setlocale (LC_ALL, "");
  bindtextdomain (PACKAGE, LOCALEDIR);
  textdomain (PACKAGE);
  
  progname = argv[0];
  while((argc > 1) && (argv[1][0] == '-'))
    {
      char * pos = argv[1];
      pos++;
      while(*pos)
        {
          switch(*pos)
            {
              case 'v':
                verbose++;
                break;
              case 'c':
                current=1;
                break;
              default:
                fprintf(stderr, gettext("%s: unknown parameter %c\n"), progname, *pos);
            }
          pos++;
        }
      argv++;
      argc--;
    }

  if (argc >= 3)
    {
      seclevel=strtol(argv[1],0,10);
      if(verbose)
        {
          if(current)
            printf(gettext("%s: executing %s with current_sec_level %i\n"),
                   progname,argv[2],seclevel);
          else
            printf(gettext("%s: executing %s with maximum_sec_level %i\n"),
                   progname,argv[2],seclevel);
        }
      if(current)
        res = rsbac_mac_set_curr_seclevel(seclevel);
      else
        res = rsbac_mac_set_max_seclevel(seclevel);
      error_exit(res);
      res = execvp(argv[2],&argv[2]);
      error_exit(res);
    }
  else
    {
      printf(gettext("%s (RSBAC %s)\n***\n"), argv[0], VERSION);
      printf(gettext("Use: %s [-v] [-c] seclevel prog args\n"), progname);
      printf(gettext("This program will set rsbac_mac_max_seclevel to seclevel and then\n"));
      printf(gettext("execute prog via execvp()\n"));
      printf(gettext("-v = verbose, -c = set current, not max_seclevel\n"));
    }
  return (res);
}

